
#include<Complex.h>
#include"LibNic.h"
#include"Symmetry.h"

/*****************************************************************************/

Symmetry::Symmetry(int sx_,int sy_,int sz_)

{ sx=sx_;
  sy=sy_;
  sz=sz_; 
                           
  if ((sx!=1)&&(sx!=0)&&(sx!=-1)) FatalError("Symmetry(x)\n");
  if ((sy!=1)&&(sy!=0)&&(sy!=-1)) FatalError("Symmetry(y)\n");
  if ((sz!=1)&&(sz!=0)&&(sz!=-1)) FatalError("Symmetry(z)\n");
}

Symmetry::Symmetry(const Symmetry& s)

{ sx=s.sx;
  sy=s.sy;
  sz=s.sz;
}

Tensor Symmetry::SX() const

{ Tensor T=Tensor(zeros);
  T.x.x= 1;
  T.y.y=-1;
  T.z.z=-1;

 return sx*T;
}

Tensor Symmetry::SY() const

{ Tensor T=Tensor(zeros);
  T.x.x=-1;
  T.y.y= 1;
  T.z.z=-1;

 return sy*T;
}

Tensor Symmetry::SZ() const

{ Tensor T=Tensor(zeros);
  T.x.x=-1;
  T.y.y=-1;
  T.z.z= 1;

 return sz*T;
}

/*****************************************************************************/

