#if !defined(_TRIPLET_)
#define _TRIPLET_

#include <iostream.h>
#include <strstream.h>
#include <string.h>

template<class TYPE>
class Triplet{
public:
  TYPE x,y,z;
  int Read(istream& Cin);
  int Write(ostream& Cout) const;

  Triplet(){x=0;y=0;z=0;};
  Triplet(TYPE X,TYPE Y,TYPE Z){x=X;y=Y;z=Z;};
  Triplet(const Triplet<TYPE>& t){x=t.x;y=t.y;z=t.z;};
  
  friend Triplet<TYPE> MakeTriplet(const TYPE& t);
  friend Triplet<TYPE> operator+(const Triplet<TYPE>&,const Triplet<TYPE>&);
  friend Triplet<TYPE> operator-(const Triplet<TYPE>&,const Triplet<TYPE>&);
  friend Triplet<TYPE> operator*(const TYPE,Triplet<TYPE>&);
  friend Triplet<TYPE> operator*(const Triplet<TYPE>&,TYPE);
  friend Triplet<TYPE> operator-(const Triplet<TYPE>&);
};

class Loop3d : public Triplet<int> {
 protected:
  int pContinue;
  Triplet<int> pInitialValue, pBound; 
public:
  Loop3d(Triplet<int> InitialValue,Triplet<int> Bound);
  Loop3d(Triplet<int> Bound);
  int Continue(){ return pContinue;};
  Loop3d& operator ++(int);
};

class Loop2d : public Loop3d {
 protected:
 public:
  Loop2d(Triplet<int> InitialValue,Triplet<int> Bound);
  Loop2d(Triplet<int> Bound);
};

template<class TYPE>
ostream& operator<<(ostream& Cout,const Triplet<TYPE>&);

template<class TYPE>
istream& operator>>(istream& Cin,Triplet<TYPE>&);


#if !defined(DYNAMICTEMPLATE)
#include "TripletTPL.h"
#endif

#endif

