C  For all the different kind of Green's tensor, this small program write the 
C  value of:
C
C  1) the Green's tensor Gel(rp,r), 
C  2) the magnetic Green's tensor Gma(rp,r), 
C  3) the farfield Green's tensor Gff(rp,n),  (n=r)
C  4) the M and the L terms


      PROGRAM
      COMPLEX*16 cKref, cEref
      REAL*8     D, dTheta
C
      REAL*8 r(3), rp(3)
      COMPLEX*16 t(3,3)
      INTEGER l, itype

C Wavenumber in the reference medium
         cKref=dcmplx(10.d0,0.d0)

C Permittivity of the reference medium
         cEref=dcmplx(2.d0,0.d0)

C Angle of propagation for the general 2D problem
         dTheta=1.5708d0

C Size of the cell
         D=0.01d0

C Position of observation
         r(1)=0.1d0
         r(2)=0.2d0
         r(3)=0.3d0

C Position of the source
         rp(1)=4d0
         rp(2)=3d0
         rp(3)=2d0

      do l=1,8
         if (l.eq.1) itype=2 
         if (l.eq.2) itype=21 
         if (l.eq.3) itype=22 
         if (l.eq.4) itype=3 
         if (l.eq.5) itype=-2 
         if (l.eq.6) itype=-21 
         if (l.eq.7) itype=-22 
         if (l.eq.8) itype=-3 

C initialize the Green's tensor 
         call grtset(itype,cKref,cEref,D,dTheta)
         call grtprint()
C L
         call grtl(t)
         write(6,*) 'L'
         call  printtensor(t)
C M
         call grtm(t)
         write(6,*) 'M'
         call  printtensor(t)
C Gel
         call grtgel(t,r,rp)
         write(6,*) 'Gel'
         call  printtensor(t)
C Gma
         call grtgma(t,r,rp)
         write(6,*) 'Gma'
         call  printtensor(t)
C GelFF
         call grtgelff(t,r,rp)
         write(6,*) 'GelFF'
         call  printtensor(t)
      enddo
C
      END
 
      subroutine printtensor(t)
C
      COMPLEX*16 t(3,3)
C
      do i=1,3
         write(6,9999) t(i,1),t(i,2),t(i,3)
      enddo
C 9999 format(6e12.4)      
 9999 format(12f12.6)      
      end
